diff --git a/service/src/test/java/com/qsjnic/mcu/service/feature/KeyFeatureTest.java b/service/src/test/java/com/qsjnic/mcu/service/feature/KeyFeatureTest.java
new file mode 100644
index 0000000..5d8be70
--- /dev/null
+++ b/service/src/test/java/com/qsjnic/mcu/service/feature/KeyFeatureTest.java
@@ -0,0 +1,25 @@
+package com.qsjnic.mcu.service.feature;
+
+import com.qsjnic.mcu.domain.Cmds;
+import com.qsjnic.mcu.domain.MsgType;
+
+import org.junit.Test;
+
+import static org.junit.Assert.*;
+
+public class KeyFeatureTest {
+
+    @Test
+    public void acceptsOnlyKey() {
+        KeyFeature f = new KeyFeature();
+        assertTrue(f.accepts(MsgType.KEY));
+        assertFalse(f.accepts(MsgType.PUBLIC));
+        assertFalse(f.accepts(MsgType.RADIO));
+    }
+
+    @Test
+    public void keyFrame_doesNotCrash() {
+        KeyFeature f = new KeyFeature();
+        f.onFrame(0x06, MsgType.KEY, Cmds.Key.M2A_KEY, new byte[] { 0x01, 0x01 });
+    }
+}
diff --git a/service/src/test/java/com/qsjnic/mcu/service/feature/VehicleFeatureTest.java b/service/src/test/java/com/qsjnic/mcu/service/feature/VehicleFeatureTest.java
index a332ac8..c4c0685 100644
--- a/service/src/test/java/com/qsjnic/mcu/service/feature/VehicleFeatureTest.java
+++ b/service/src/test/java/com/qsjnic/mcu/service/feature/VehicleFeatureTest.java
@@ -13,8 +13,8 @@ public class VehicleFeatureTest {
     @Test
     public void voltageFrame_updatesSnapshot() {
         VehicleFeature f = new VehicleFeature(null);
-        f.onFrame(0x06, MsgType.PUBLIC, Cmds.Public.M2A_VOLTAGE, new byte[]{0x30, (byte)0xD4});
-        assertEquals(0x30D4, f.snapshot().voltageMv);
+        f.onFrame(0x06, MsgType.PUBLIC, Cmds.Public.M2A_VOLTAGE, new byte[]{0x00, (byte)0x80});
+        assertEquals(12800, f.snapshot().voltageMv);
     }
 
     @Test
@@ -53,6 +53,7 @@ public class VehicleFeatureTest {
     public void acceptsOnlyPublic() {
         VehicleFeature f = new VehicleFeature(null);
         assertTrue(f.accepts(MsgType.PUBLIC));
+        assertFalse(f.accepts(MsgType.KEY));
         assertFalse(f.accepts(MsgType.RADIO));
         assertFalse(f.accepts(MsgType.UPDATE));
     }
